/*	-*-C-*- (Just help Emacs)
**	Name	:	cyril
**	Date	:	Sat Jan 15 12:05:26 1994
**	Subjetc	:	The include file for dpt driver
**	File	:	dpt.h
**	Modif	:	Sat Jan 15 12:05:52 1994
**	Version	:	$Id$
*/

/*
** $Log$
*/

#include <linux/types.h>


#define TRUE 1
#define FALSE 0
#define TIMEOUT 500
#define DPT_MAILBOXES 32
#define DPT_SCATTER 16
#define DPT_CMDLUN 2

#define REG_CMD         7
#define REG_STATUS      7
#define REG_AUX_STATUS  8
#define REG_DATA        0
#define REG_DATA2       1
#define REG_SEE         6

#define REG_LOW         2
#define REG_LM          3
#define REG_MID         4
#define REG_MSB         5

struct dpt_info {
  ulong  data_len ;
  ulong  sign ;

  unchar version:4,
                :4;

  unchar  ocsena:1,
         tarsup:1,
         :2,
         dmasup:1,
         drqvld:1,
         ata:1,
         haaval:1;
  
  ushort cp_pad_len ;
  ulong  host_adr ;
  ulong  cp_len ;
  ulong  sp_len ;
  ushort queue_len ;
  ushort nil ;
  ushort scatt_size;

  unchar  irq:4,
          irq_tr:1,
          second:1,
          drqx:2;

  unchar  sync;
  ushort filler[250];

};

struct dpt_config {
  ushort len;
  unchar edis:1,
         ocena:1,
         mdpena:1,
         tarena:1,
         nul:4;
  unchar zero;
  unchar filler[510] ; /* Burk ;-) */
}  ;

struct sg {
  unsigned long adress;
  unsigned long len;
};

/* The struct DPT */

struct dpt_ccb_cp {

  unchar sreset:1,
         init:1,
         reqsen:1,
         sg:1,
         nul:1,
         intr:1,
         dout:1,
         din:1;

  unchar rsl;
  unchar unused[4];

  unchar phsunit:1,
         notused:7;

  unchar devadr;

  unchar lun:3,
         zero1:1,
         zero2:1,
         luntar:1,
         dispri:1,
         one:1;

  unchar mess1;
  unchar mess2;
  unchar mess3;
  unchar cdb[12];
  ulong  data_trans_len;
  ulong  vir_cp;
  ulong  data_adr;
  ulong  sp_adr;
  ulong  res_sens_adr;
};

/* The SP retrun structure */
      
struct dpt_ccb_sp {

  unchar cont_stat:7,
         eoc:1;
  unchar scsi_stat;
  unchar nul1,nul2;
  ulong  inv_res_len;
  ulong  vir_cp;
  char  mess[12];
};

/*
** unused because this is a joke from DPT 
** and of corse it doesn't work
*/

struct status {
  
  unchar    error:1, 
           more:1,
           corr:1,
           drq:1,
           sc:1,
           fault:1,
           rdy:1,
           bsy:1;
} ;

/*
** La declaration des prototypes
*/


int dpt_detect(int);
int dpt_command(Scsi_Cmnd *);
int dpt_queuecommand(Scsi_Cmnd *, void (*done)(Scsi_Cmnd *));
int dpt_abort(Scsi_Cmnd *, int);
const char *dpt_info(void);
int dpt_reset(Scsi_Cmnd *);
int dpt_biosparam(int, int, int*);
void dpt_intr(int);

/*
** Info for middle SCSI ware
*/


#define DPT {"DPT 2122", dpt_detect,	\
		dpt_info, dpt_command,		\
		dpt_queuecommand,			\
		dpt_abort,				\
		dpt_reset,				\
	        NULL,		                        \
		dpt_biosparam,                      \
		DPT_MAILBOXES, 7, 60, DPT_CMDLUN \
		  , 0, 1}



